# Generated by rust2rpm 15
%bcond_without check
%global __cargo_skip_build 0

%global dracutmodulesdir %(pkg-config --variable=dracutmodulesdir dracut || echo '/usr/lib/dracut/modules.d')

%global crate afterburn

Name:           rust-%{crate}
Version:        5.3.0
Release:        1.rhaos4.12%{?dist}
Summary:        Simple cloud provider agent

# Upstream license specification: Apache-2.0
License:        ASL 2.0
URL:            https://crates.io/crates/afterburn
Source0:        https://crates.io/api/v1/crates/%{crate}/%{version}/download#/%{crate}-%{version}.crate
# Comment out this conditional on Fedora
Source1:        https://github.com/coreos/%{crate}/releases/download/v%{version}/%{crate}-%{version}-vendor.tar.gz
ExclusiveArch:  %{rust_arches}

Patch0001:      0001-Dracut-change-module-setup-for-rhcos.patch
Patch0002:      0002-Turn-on-Afterburn-hostname-support-for-GCP.patch

%if 0%{?rhel} && !0%{?eln}
BuildRequires:  rust-toolset
BuildRequires:  openssl-devel
# This is needed because the cc crate, which is
# used for linking final build results of crates,
# does not work without it.
BuildRequires:  glibc-devel
%else
BuildRequires:  rust-packaging
%endif
BuildRequires:  systemd

%global _description %{expand:
Simple cloud provider agent.}

%description %{_description}

%package     -n %{crate}
Summary:        %{summary}
# ASL 2.0
# ASL 2.0 or Boost
# BSD
# MIT
# MIT or ASL 2.0
# MPLv2.0 or MIT or ASL 2.0
# Unlicense or MIT
# zlib
License:        ASL 2.0 and MIT and BSD and zlib
%{?systemd_requires}

%description -n %{crate} %{_description}

%files       -n %{crate}
%license LICENSE
%doc README.md
%{_bindir}/afterburn
%{_unitdir}/afterburn.service
%{_unitdir}/afterburn-checkin.service
%{_unitdir}/afterburn-firstboot-checkin.service
%{_unitdir}/afterburn-sshkeys@.service
%{_unitdir}/afterburn-sshkeys.target

%post        -n %{crate}
%systemd_post afterburn.service
%systemd_post afterburn-checkin.service
%systemd_post afterburn-firstboot-checkin.service
%systemd_post afterburn-sshkeys@.service

%preun       -n %{crate}
%systemd_preun afterburn.service
%systemd_preun afterburn-checkin.service
%systemd_preun afterburn-firstboot-checkin.service
%systemd_preun afterburn-sshkeys@.service

%postun      -n %{crate}
%systemd_postun afterburn.service
%systemd_postun afterburn-checkin.service
%systemd_postun afterburn-firstboot-checkin.service
%systemd_postun afterburn-sshkeys@.service

%package     -n %{crate}-dracut
Summary:        Dracut modules for afterburn
BuildRequires:  pkgconfig(dracut)
Requires:       %{crate}%{?_isa} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       dracut
Requires:       dracut-network

%description -n %{crate}-dracut
Dracut module that enables afterburn and corresponding services
to run in the initramfs on boot.

%files       -n %{crate}-dracut
%{dracutmodulesdir}/30afterburn/

%prep
%autosetup -n %{crate}-%{version} -p1
%if 0%{?rhel} && !0%{?eln}
tar xvf %{SOURCE1}
mkdir -p .cargo
cat >.cargo/config << EOF
[source.crates-io]
replace-with = "vendored-sources"

[source.vendored-sources]
directory = "vendor"
EOF
%else
%cargo_prep
%endif
# afterburn-sshkeys@.service is by default enabled for the 'core' user in
# RHEL CoreOS.
# Based on https://github.com/coreos/afterburn/blob/master/Makefile.
sed -e 's,@DEFAULT_INSTANCE@,core,' < \
  systemd/afterburn-sshkeys@.service.in > \
  systemd/afterburn-sshkeys@.service

%if !0%{?rhel} || 0%{?eln}
%generate_buildrequires
%cargo_generate_buildrequires
%endif

%build
%cargo_build

%install
%if 0%{?rhel} && !0%{?eln}
%make_install INSTALL="install -p -c"
%else
%cargo_install
install -Dpm0644 -t %{buildroot}%{_unitdir} \
  systemd/*.service systemd/*.target
%endif
mkdir -p %{buildroot}%{dracutmodulesdir}
cp -a dracut/* %{buildroot}%{dracutmodulesdir}

%if %{with check}
%check
%cargo_test
%endif

%changelog
* Mon May 2 2022 Sohan Kunkerkar <skunkerk@redhat.com> - 5.3.0-1
- Update to 5.3.0

* Fri Jan 14 2022 Benjamin Gilbert <bgilbert@redhat.com> - 5.2.0-1
- Update to 5.2.0

* Tue Dec 14 2021 Sohan Kunkerkar <skunkerk@redhat.com> - 5.1.0-2
- Vendor rust dependencies only on RHEL
- add afterburn-dracut subpackage

* Wed Aug 11 2021 Sohan Kunkerkar <skunkerk@redhat.com> - 5.1.0-1
- Update to 5.1.0

* Fri Apr 9 2021 Sohan Kunkerkar <skunkerk@redhat.com> - 5.0.0-1
- Update to 5.0.0

* Mon Dec 14 2020 Sohan Kunkerkar <skunkerk@redhat.com> - 4.6.0-1
- Update to 4.6.0

* Fri Oct 30 2020 Nikita Dubrovskii <ndubrovs@redhat.com> - 4.5.3-2
- quickfix to enable afterburn-hostname.service on GCP

* Wed Oct 21 2020 Sohan Kunkerkar <skunkerk@redhat.com> - 4.5.3-1
- Update to 4.5.3

* Tue Oct 20 2020 Sohan Kunkerkar <skunkerk@redhat.com> - 4.5.2-1
- Update to 4.5.2

* Fri Sep 18 2020 Luca BRUNO <lucab@redhat.com> - 4.5.0-2
- vendor/vmw_backdoor: quickfix to skip performing iopl
  <https://bugzilla.redhat.com/show_bug.cgi?id=1877995>

* Fri Aug 07 2020 Luca BRUNO <lucab@redhat.com> - 4.5.0-1
- Update to 4.5.0

* Fri Jul 17 2020 Luca BRUNO <lucab@redhat.com> - 4.4.2-1
- Update to 4.4.2

* Fri Jun 05 2020 Luca BRUNO <lucab@redhat.com> - 4.4.0-1
- Update to 4.4.0

* Wed May 6 2020 Robert Fairley <rfairley@redhat.com> - 4.3.3-1
- Update to 4.3.3

* Wed Jul 17 2019 Yu Qi Zhang <jerzhang@redhat.com> - 4.1.1-3
- Add patch for relabelling hostname file

* Tue Jul 16 2019 Yu Qi Zhang <jerzhang@redhat.com> - 4.1.1-2
- Add patch for RHCOS to link afterburn-hostname to ignition-files

* Fri Jun 21 2019 Steve Milner <smilner@redhat.com> - 4.1.1-1
- Update for upstream release
- Add 30afterburn for dracut

* Wed May 22 2019 Yu Qi Zhang <jerzhang@redhat.com> - 4.1.0-1
- Initial package imported from upstream
